package rs2gprs;

import javax.microedition.midlet.MIDlet;
import javax.microedition.midlet.MIDletStateChangeException;

import com.siemens.icm.io.ATCommand;


public class Main extends MIDlet {

	ATCommand		atCommand; 
	Tc65SerialPort	tc65SerialPort;
	String 			strAPN;		// Sometimes APN needs to be set using AT command
	String 			strUrl;
	String 			strParams; // if we are sending params in a separate line
	ServerThread 	server;
	boolean 		bServerCreated = false;
	
	/********************************************************
	 *   ( ) 
	 ********************************************************/
	public Main() {
		try
		{
	        atCommand = new ATCommand(false);
	        tc65SerialPort = new Tc65SerialPort();
	        strUrl = new String();
	        strParams = new String();
	        strAPN = new String();
	        serialOut("\r\nHTTPServer build 120322 SMTK R3\r\n\r\n");
	        serialOut("If you get \"class java.io.IOException : Profile could not be activated\" message" +
	        		" it can mean you need to enter proper APN.\r\n");
		}
		catch(Exception e) 
		{
			System.out.println(e);
			notifyDestroyed();
		}
	}

	protected void destroyApp(boolean arg0) throws MIDletStateChangeException {
		System.out.println("destroyApp(" + arg0 + ")");

        notifyDestroyed();    

	}

	protected void pauseApp() {

	}
	/**
	 * Wrappers for debug output to serial port
	 * @param str
	 */
	void serialOut(String str)
	{
		tc65SerialPort.serialOut(str.getBytes());
	}
	void serialOut(byte[] ar)
	{
		tc65SerialPort.serialOut(ar);
	}
	void serialOut(char c)
	{
		tc65SerialPort.serialOut(c);
	}
	void DebugOut(String str)
	{
		tc65SerialPort.serialOut(str.getBytes());
	}
	void DebugOut(byte[] ar)
	{
		tc65SerialPort.serialOut(ar);
	}

	void ShowMenu()
	{
		serialOut("\r\nMenu\r\n");
		serialOut("====\r\n");
		serialOut("A: enter APN and select it (needed by some operators)\r\n");
		serialOut("S: start single threaded server\r\n");
		serialOut("M: start multithreaded server\r\n");
		serialOut("K: kill server\r\n");
		serialOut("?: show server threads state\r\n");
		serialOut("Q: exit\r\n");
		serialOut("Enter: show this help\r\n");
	}

	protected void startApp() throws MIDletStateChangeException {

 		DebugOut("Applet loaded\n\r");
 		
		boolean bExit = false;

		StringBuffer sbInputString = new StringBuffer(128);

		int State = 0; 

		ShowMenu();
		
		while(bExit == false)
        {
        	// Talk to terminal connected to modem's COM port
			while(tc65SerialPort.hasData() > 0)
			{
				char c = (char)tc65SerialPort.readByte();
			
				if(State > 0)
				{
					if(c == 13) // Enter
					{
						switch(State)
						{
						case 3:
							strAPN = sbInputString.toString();
							serialOut("\r\nNew APN: " + 
									strAPN + "\r\n");
							String s = new String("response");
							try
							{
								s = atCommand.send("AT^SJNET=\"gprs\",\"" + 
										strAPN + 
										"\",\"\",\"\",\"\",30\r\n");
								serialOut("\r\nSetting APN: " + s + "\r\n");
							}
							catch(Exception e)
							{
				            	serialOut( "Excp (atCommand.send()): " + e.getClass() + " : " + e.getMessage() + "\r\n");
							}
							break;
						}
						State = 0;
					}
					else
					{
						sbInputString.append(c);
						serialOut(c);
					}
				} // State > 0
				else
				{
					switch(c)
					{
					case 'Q': case 'q':
						bExit = true;
						break;
					case 'M': case 'm':
						if(bServerCreated == true)
						{
							if(server.isAlive())
							{
								serialOut("Server is still alive, kill it first to release socket\r\n");
								break;
							}
						}
						server = new ServerThread(tc65SerialPort);
						server.bShowDebug = true; // Server will show debug output
						server.bRunMultithreadedServer = true; // Use multiple threads 
						
						bServerCreated = true;
						serialOut("Calling server.start()\r\n");
						server.start();
						break;
					case 'S': case 's':
						if(bServerCreated == true)
						{
							if(server.isAlive())
							{
								serialOut("Server is still alive, kill it first to release socket\r\n");
								break;
							}
						}
						server = new ServerThread(tc65SerialPort);
						server.bShowDebug = true; // Server will show debug output
						server.bRunMultithreadedServer = false; // Use multiple threads 
						
						bServerCreated = true;
						serialOut("Calling server.start()\r\n");
						server.start();
						break;
					case 'K': case 'k':
						server.stopThread(); // Server will die after that. 
						break;
					case '?': 
						if(bServerCreated == false)
							serialOut("Server was not created yet\r\n");
						else
							serialOut("server.isAlive() = " + ((server.isAlive()==true)?"TRUE":"FALSE") + "\r\n");
						serialOut("Now running " + Thread.activeCount() + "threads\r\n");
						break;
					case 'A': case 'a':
						sbInputString = new StringBuffer(128); 
						serialOut("Enter new APN: ");
						State = 3;
						break;
					case 13:
						ShowMenu();
						break;
					}
				}

			}
        }
        
        DebugOut("\n\rDestroying...\n\r");
		tc65SerialPort.Close();
		destroyApp(true);
	}


}
